﻿using System.Diagnostics.CodeAnalysis;

namespace ProjectBoat.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawiningBoatEqutables : IEqualityComparer<DrawningBoat?>
{
    public bool Equals(DrawningBoat? x, DrawningBoat? y)
    {
        if (x == null || x.EntityBoat == null)
        {
            return false;
        }

        if (y == null || y.EntityBoat == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityBoat.Speed != y.EntityBoat.Speed)
        {
            return false;
        }

        if (x.EntityBoat.Weight != y.EntityBoat.Weight)
        {
            return false;
        }

        if (x.EntityBoat.BodyColor != y.EntityBoat.BodyColor)
        {
            return false;
        }

        if (x is DrawningMBoat && y is DrawningMBoat)
        {
            // TODO доделать логику сравнения дополнительных параметров
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawningBoat obj)
    {
        return obj.GetHashCode();
    }
}
