﻿using ProjectBoat.Entities;

namespace ProjectBoat.Drawnings;

/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>
public class DrawningBoatCompareByColor : IComparer<DrawningBoat?>
{
    public int Compare(DrawningBoat? x, DrawningBoat? y)
    {
        // TODO прописать логику сравения по цветам, скорости, весу
        if (x == null || x.EntityBoat == null)
        {
            return 1;
        }

        if (y == null || y.EntityBoat == null)
        {
            return -1;
        }
        var bodycolorCompare = x.EntityBoat.BodyColor.Name.CompareTo(y.EntityBoat.BodyColor.Name);
        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }
        var speedCompare = x.EntityBoat.Speed.CompareTo(y.EntityBoat.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityBoat.Weight.CompareTo(y.EntityBoat.Weight);
    }
}
